/*
 * $Id$
 * --------------------------------------------------------------------------------------
 * Copyright (c) MuleSource, Inc.  All rights reserved.  http://www.mulesource.com
 *
 * The software in this package is published under the terms of the CPAL v1.0
 * license, a copy of which has been included with this distribution in the
 * LICENSE.txt file.
 */
package org.mule.ibeans.b2t;

import org.mule.ibeans.api.application.Receive;
import org.mule.ibeans.api.application.Schedule;
import org.mule.ibeans.api.client.IntegrationBean;
import org.mule.ibeans.twitter.TwitterIBean;
import org.mule.ibeans.bitly.BitlyIBean;

import java.net.URL;

import javax.annotation.PostConstruct;

import org.apache.abdera.model.Entry;

public class BlogToTwitter
{
    public static final String BLOG_URL = "atom:http://rossmason.blogspot.com/feeds/posts/default";

    @IntegrationBean
    private TwitterIBean twitter;

    @IntegrationBean
    private BitlyIBean bitly;

    @PostConstruct
    public void init()
    {
        bitly.init("bitlyapidemo", "R_0da49e0a9118ff35f52f629d2d71bf07");

        throw new IllegalStateException("You need to set your twitter credentials.");
        //twitter.setCredentials("ross", "shhh");
    }

    @Schedule(interval = 6000)
    @Receive(uri = BLOG_URL)
    public void processEntry(Entry entry) throws Exception
    {
        StringBuffer tweet  = new StringBuffer(140);
        tweet.append(entry.getTitle());
        String url = entry.getAlternateLink().getHref().toString();

         //shorted the title to 120 chars
        if (tweet.length() > 120)
        {
            tweet.delete(120, tweet.length()).append("..");
        }

        //Shorten the url
        URL shortUrl = bitly.getShortenedURL(url);

        //Add the short URL to the Tweet
        tweet.append(" : ").append(shortUrl);

        twitter.statusesUpdate(tweet.toString());
    }
}
